/**
 * @flow
 * @jsx React.DOM
*/
var React = require('react');

var ArrayMixin = {
  statics: {
    array: true
  },

  propTypes: {
    collection: React.PropTypes.oneOfType([
      React.PropTypes.array,
      React.PropTypes.object
    ]).isRequired
  },

  renderChildren:function()                       {
    var c = this.props.collection;

    if (Array.isArray(this.props.collection)) {
      c = this._mapArrayCollectionToObject();
    }

    return Object.keys(c).map(function(k)  {return this.renderChild(k, c[k]);}.bind(this), this);
  },

  _mapArrayCollectionToObject:function()         {
    var c = {};
    this.props.collection.forEach(function(v)  {return c[v] = v;});
    return c;
  }
};

module.exports = ArrayMixin;
