/**
 * @flow
 * @jsx React.DOM
*/
var React = require('react');
var type = require('type-detect');
var ArrayMixin = require('./mixins/array');

var Radio = React.createClass({displayName: "Radio",
  mixins: [ArrayMixin],

  propTypes: {
    defaultValue: React.PropTypes.any,
    value: React.PropTypes.any
  },

  render:function()                {
    return (
      React.createElement("span", {id: this.props.getId()}, 
        this.renderChildren()
      )
    );
  },

  renderChild:function(key     , value     )                {
    var lk = key.toString().toLowerCase();
    var id = [this.props.getId(), lk].join('_');

    return (
      React.createElement("label", {key: lk, htmlFor: id}, 
        React.createElement("input", {type: "radio", onChange: this._handleChange, id: id, name: this.props.getName(), checked: this._isChecked(value), value: value}), 
        key
      )
    );
  },

  _isChecked:function(value     )          {
    var pv = this.props.getValue();

    if (type(pv) !== 'undefined') {
      return (pv === value);
    } else if (type(this.props.defaultValue) !== 'undefined') {
      return (this.props.defaultValue === value);
    }

    return false;
  },

  _handleChange:function(e                            )       {
    if (this.props.onChange) {
      this.props.onChange(e);
      return;
    }

    this.props.setValue(e.target.value);
  }
});

module.exports = Radio;
