/**
 * @flow
 * @jsx React.DOM
*/
var React = require('react');
var ArrayMixin = require('./mixins/array');

var Select = React.createClass({displayName: "Select",
  mixins: [ArrayMixin],

  propTypes: {
    multiple: React.PropTypes.bool
  },

  getDefaultProps:function() {
    return {
      multiple: false
    };
  },

  render:function()                {
    var value = this.props.getValue();
    if (this.props.multiple === true && !Array.isArray(value)) {
      value = [value];
    }

    return (
      React.createElement("select", React.__spread({},  this.props, {id: this.props.getId(), name: this.props.getName(), onChange: this._handleChange, value: value}), 
        this.renderChildren()
      )
    );
  },

  renderChild:function(key     , value     )                {
    var lk = key.toString().toLowerCase();
    var id = [this.props.getId(), lk].join('_');

    return (
      React.createElement("option", {id: id, key: lk, value: value}, 
        key
      )
    );
  },

  _handleChange:function(e                            )       {
    if (this.props.onChange) {
      this.props.onChange(e);
      return;
    }

    var value = e.target.value;

    if (this.props.multiple === true) {
      value = Array.prototype.slice.call(e.target.children)
      .filter(function(c)  {return c.selected === true;})
      .map(function(c)  {return c.value;});
    }

    this.props.setValue(value);
  }
});

module.exports = Select;
